%define kdeprefix /opt/kde
%define version 1.1.1
%define kderelease 2
%define sourcedir stable/1.1.1/distribution/tar/generic/source
%define tag -1.1.1
%define topdirtag -1.1.1
Serial: 3

%define target RedHat 5.1 or 5.2 systems
%define compiler egcs
%define rhseries rh5x
%define redhat redhat-release >= 5.1
%define qtrequired  qt >= 1.42 qt-egcs-10x

%define rhsupport kdesupport-redhat-1.1.1
%define omit  --without-libjpeg --without-libgif --without-libgdbm 
%define omittedlibs jpeglib6a giflib30 gdbm
%define extrareq libungif libjpeg >= 6b-5 gdbm rpm >= 2.5
%define kdename kdesupport
%define topdir %{kdename}%{topdirtag}
Name: %{kdename}
Summary: K Desktop Environment - Support Libraries
Version: %{version}
Release: %{kderelease}%{rhseries}
URL: http://www.kde.org
Source: ftp://ftp.kde.org:/pub/kde/{sourcedir}/%{kdename}%{tag}.tar.gz
Source1: %{rhsupport}.tar.gz
Group: X11/KDE/Base
Copyright: GPL/LGPL
BuildRoot: /var/tmp/%{kdename}-buildroot
Provides: kdesupport-%{rhseries}
Requires: %{qtrequired} %{redhat} %{extrareq}
Distribution: KDE
Packager: KDE Packaging Team <redhat-rpms@kde.org>
Vendor: The KDE Team
Prefix: %{kdeprefix}
Prereq: /sbin/ldconfig
%define packages main javascript qwspritefield 
%define main mimelib uulib gdbm jpeglib6a giflib30
%define javascript js
%define qwspritefield QwSpriteField
%define subdirs %main %javascript %qwspritefield 


%description
Support Libraries used by the K Desktop Environment, but which are not 
part of KDE itself.

Libraries included: uulib, mimelib; depending on the Red Hat release, 
libraries gdbm, jpeg and gif are either also included, or the versions 
supplied by Red Hat are required.
(The library QwSpriteField used by the "asteroids" game is now placed in a 
separate subpackage).

This package also provides extra KDE support for Red Hat Linux: 
a script "usekde" that users can run to set up KDE as their default desktop, 
and scripts for activating the KDE X Display Manager "kdm" to replace "xdm".

This package is intended for %{target}.
It will be installed by default in %{kdeprefix}, but is relocatable to install
under e.g., /usr/kde, using "rpm --prefix /usr/kde ..."

%package qwspritefield
Summary: K Desktop Environment - Support Libraries - QwSpriteField
Group: X11/KDE/Base
Copyright: LGPL
Requires: kdesupport-%{rhseries}
Prereq: /sbin/ldconfig
Prefix: %{kdeprefix}
%description qwspritefield
This package provides the QwSpriteField library that is used by certain KDE 
games, such as the Asteroids game ("kasteroids").

This package is intended for %{target}.
It will be installed by default in %{kdeprefix}, but is relocatable to install
under e.g., /usr/kde, using "rpm --prefix /usr/kde ..."

%package javascript
Summary: K Desktop Environment - Support Libraries - js
Group: X11/KDE/Base
Copyright: LGPL
Requires: kdesupport-%{rhseries}
Provides: js
Prereq: /sbin/ldconfig
Prefix: %{kdeprefix}
%description javascript
This package provides the js (javascript) library that is needed by 
"experimental" KDE applications in development, like KOffice.  It is
NOT needed by the regular KDE-1.1 distribution.   It is recommended that
you get full the js distribution from htt://www.ngs.fi/js; this package
only provides a small part of the full js distribution.


This package is intended for %{target}.
It will be installed by default in %{kdeprefix}, but is relocatable to install
under e.g., /usr/kde, using "rpm --prefix /usr/kde ..."

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q -n %{topdir}

# extra scripts for redhat
%setup -q -n %{topdir} -T -D -a 1

%build
export KDEDIR=%{kdeprefix}
CC=%{compiler} ./configure --prefix=%{kdeprefix} --with-install-root=$RPM_BUILD_ROOT --disable-path-check %{omit}
make 

%install
export KDEDIR=%{kdeprefix}
for subdir in %{subdirs} ; do
   install="yes"
   for omittedlib in %{omittedlibs} ; do
	if [ "$subdir" = "$omittedlib" ] ; then
		install="no"
	fi
   done		
   if [ "$install" = "yes" ] ; then
	rm -rf $RPM_BUILD_ROOT/*
	cd $RPM_BUILD_DIR/%{topdir}/$subdir
	make prefix=$RPM_BUILD_ROOT%{kdeprefix} install-strip
	cd $RPM_BUILD_ROOT
	tar -cvf $RPM_BUILD_DIR/$subdir.tar .%{kdeprefix}
    fi
done

cd $RPM_BUILD_ROOT
for package in %{packages} ; do
	rm -rf $RPM_BUILD_ROOT/*
        pkgdirs=""
	if [ "$package" = "main" ] ; then pkgdirs="%{main}"
	elif [ "$package" = "qwspritefield" ] ; then pkgdirs="%{qwspritefield}"
	elif [ "$package" = "javascript" ] ; then pkgdirs="%{javascript}"
	fi
	for subdir in $pkgdirs ; do
	   install="yes"
  	   for omittedlib in %{omittedlibs} ; do
		if [ "$subdir" = "$omittedlib" ] ; then
			install="no"
		fi
   	   done		
 	   if [ "$install" = "yes" ] ; then
		tar -xvf $RPM_BUILD_DIR/$subdir.tar
		rm $RPM_BUILD_DIR/$subdir.tar
           fi
	done
        chmod a+x $RPM_BUILD_ROOT%{kdeprefix}/lib/*
	tar -cvf $RPM_BUILD_DIR/$package.pkg.tar .
        if ! [ "$package" = "main" ] ; then
	   find . -type d | sed '1,2d;s,^\.,\%attr(-\,root\,root) \%dir ,' > \
		$RPM_BUILD_DIR/file.list.%{kdename}.$package

           find . -type f | sed -e 's,^\.,\%attr(-\,root\,root) ,' \
		-e '/\/config\//s|^|%config|' >> \
		$RPM_BUILD_DIR/file.list.%{kdename}.$package

	   find . -type l | sed 's,^\.,\%attr(-\,root\,root) ,' >> \
		$RPM_BUILD_DIR/file.list.%{kdename}.$package
        fi
done

# now put the main package together
rm -rf $RPM_BUILD_ROOT/*
tar -xvf $RPM_BUILD_DIR/main.pkg.tar

# install the redhat post-installation scripts 
install -d $RPM_BUILD_ROOT%{kdeprefix}/bin
install -m 0755 $RPM_BUILD_DIR/%{topdir}/%{rhsupport}/scripts/usekde $RPM_BUILD_ROOT%{kdeprefix}/bin
install -m 0755 $RPM_BUILD_DIR/%{topdir}/%{rhsupport}/scripts/kdesetup $RPM_BUILD_ROOT%{kdeprefix}/bin
install -m 0755 $RPM_BUILD_DIR/%{topdir}/%{rhsupport}/scripts/kdm_on $RPM_BUILD_ROOT%{kdeprefix}/bin
install -m 0755 $RPM_BUILD_DIR/%{topdir}/%{rhsupport}/scripts/kdm_off $RPM_BUILD_ROOT%{kdeprefix}/bin

# install the default user configuration files
cd $RPM_BUILD_DIR/%{topdir}/%{rhsupport}/etc/skel
mv -f kderc .kderc
mv -f kde .kde
cp -a  $RPM_BUILD_DIR/%{topdir}/%{rhsupport}/etc $RPM_BUILD_ROOT%{kdeprefix}


#install model Xclients script.
install -m 0755 $RPM_BUILD_DIR/%{topdir}/%{rhsupport}/scripts/Xclients $RPM_BUILD_ROOT%{kdeprefix}/etc/skel/.Xclients


install -d $RPM_BUILD_ROOT%{kdeprefix}/etc/profile.d


# Generating the filelist for the main package (files in %{kdename})
cd $RPM_BUILD_ROOT
find . -type d | sed '1,2d;s,^\.,\%attr(-\,root\,root) \%dir ,' > $RPM_BUILD_DIR/file.list.%{kdename}.main
find . -type f | sed 's,^\.,\%attr(-\,root\,root) ,' >> $RPM_BUILD_DIR/file.list.%{kdename}.main
find . -type l | sed 's,^\.,\%attr(-\,root\,root) ,' >> $RPM_BUILD_DIR/file.list.%{kdename}.main


#install initialization scripts which may be modified by %post.
install -m 0755 $RPM_BUILD_DIR/%{topdir}/%{rhsupport}/scripts/kde.sh $RPM_BUILD_ROOT%{kdeprefix}/etc/profile.d/kde.sh
install -m 0755 $RPM_BUILD_DIR/%{topdir}/%{rhsupport}/scripts/kde.csh $RPM_BUILD_ROOT%{kdeprefix}/etc/profile.d/kde.csh
find .%{kdeprefix}/etc/profile.d -type f | sed 's,^\.,\%attr(-\,root\,root) %verify(not mode size mtime md5) ,' >> $RPM_BUILD_DIR/file.list.%{kdename}.main

#install user default config files which may get modified by %post
cd $RPM_BUILD_DIR/%{topdir}/%{rhsupport}/share/session
for file in * ; do
     mv $file  ../config
done
cp -a ../config/* $RPM_BUILD_ROOT%{kdeprefix}/etc/skel/.kde/share/config
cd $RPM_BUILD_ROOT
find .%{kdeprefix}/etc/skel/.kde/share/config -type f | sed 's,^\.,\%attr(-\,root\,root) %verify(not mode size mtime md5) ,' >> $RPM_BUILD_DIR/file.list.%{kdename}.main

cd $RPM_BUILD_ROOT
tar -cvf $RPM_BUILD_DIR/main.pkg.tar .
rm -rf $RPM_BUILD_ROOT/*

# put back subpackage files
cd $RPM_BUILD_ROOT
for package in %{packages} ; do
		tar -xvf $RPM_BUILD_DIR/$package.pkg.tar
done



%clean
rm -rf $RPM_BUILD_ROOT
for package in %{packages} ; do
	rm -f $RPM_BUILD_DIR/file.list.%{kdename}.$package
	rm -f $RPM_BUILD_DIR/$package.pkg.tar
done


%post
grep -q "$RPM_INSTALL_PREFIX/lib" /etc/ld.so.conf || echo "$RPM_INSTALL_PREFIX/lib" >> /etc/ld.so.conf
/sbin/ldconfig

# edit/install files that explicitly refer to  $KDEDIR
if ! [ -d /etc/profile.d ] ; then
	install -d /etc/profile.d
fi
cd $RPM_INSTALL_PREFIX/etc/profile.d
for file in  kde.sh kde.csh ; do
     mv -f $file $file.tmp
     sed -e "s^@KDEPREFIX@^$RPM_INSTALL_PREFIX^g" $file.tmp > $file
     rm -f $file.tmp
     install -m 0755 $file /etc/profile.d/$file
done
cd $RPM_INSTALL_PREFIX/etc/skel/.kde/share/config
for file in * ; do
     grep "@KDEPREFIX@" $file > $file.tmp
     if [ -s $file.tmp ] ; then
	mv -f $file $file.tmp
     	sed -e "s^@KDEPREFIX@^$RPM_INSTALL_PREFIX^g" $file.tmp > $file
     fi
     rm -f $file.tmp
done

%preun
# if KDE is being removed, run kdm_off script to reverse any changes to
# /etc/inittab and /etc/X11/xdm/Xsetup_0 made by kdm_on:
if [ "$1" = "0" ] ; then
     if grep kdm /etc/inittab > /dev/null ; then
     $RPM_INSTALL_PREFIX/bin/kdm_off
     fi
fi 

%postun
if ! [ -d $RPM_INSTALL_PREFIX/lib ] ; then
	cp -f /etc/ld.so.conf /etc/ld.so.conf.temp
	grep -v "^$RPM_INSTALL_PREFIX/lib$" /etc/ld.so.conf.temp > /etc/ld.so.conf
	rm /etc/ld.so.conf.temp
	/sbin/ldconfig
fi
if [ "$1" = "0" ] ; then
	rm -rf /etc/profile.d/kde.sh
	rm -rf /etc/profile.d/kde.csh
fi


%post qwspritefield
/sbin/ldconfig

%postun qwspritefield
/sbin/ldconfig

%post javascript
/sbin/ldconfig

%postun javascript
/sbin/ldconfig

%files  -f ../file.list.%{kdename}.main
%files qwspritefield -f ../file.list.%{kdename}.qwspritefield
%files javascript -f ../file.list.%{kdename}.javascript


%changelog
* Sun Apr 18 1999 <duncan@kde.org> 
- updated for KDE-1.1.1

* Thu Mar 18 1999 <duncan@kde.org>
- kdm_on script now adds utmp/wtmp support for kdm  (so commands like 
- who, finger, last, etc., see users logged in with kdm)

* Tue Mar 2 1999 <duncan@kde.org>
- added a subpackage for the javascript library

* Wed Feb 17 1999 <duncan@kdeorg>
- removed kdesupport-install-kde to its own rpm package

* Sat Feb 13 1999 <duncan@kde.org>
- files in KDEDIR/share/applnk no longer treated as %config files

* Fri Feb 12 1999 <duncan@kde.org>
- extra subpackage kdesupport-install-kde now
- has the docs, plus scripts for the installation

* Mon Feb 8 1999 <duncan@kde.org>
- new rpm packaging for KDE-1.1
- relocatable rpms
- individual apps in subpackages
- enhanced support for Red Hat in kdesupport rpm



